#include <p18f2550.h>               //  PIC18F2550

typedef unsigned char   Byte;       // 8-bit
typedef unsigned int    Word;       // 16-bit
typedef unsigned long   DWord;      // 32-bit

/** configulation *******************************************/
                                    // 20MHz -> 24MHz
#pragma config PLLDIV = 5
#pragma config CPUDIV = OSC3_PLL4
#pragma config USBDIV = 2

#pragma config FOSC = HSPLL_HS
#pragma config IESO = OFF

#pragma config PWRT = OFF
#pragma config BOR = ON
#pragma config VREGEN = ON
#pragma config WDT = OFF
#pragma config WDTPS = 1

#pragma config MCLRE = ON
#pragma config LPT1OSC = OFF
#pragma config PBADEN = OFF
#pragma config CCP2MX = OFF

#pragma config STVREN = OFF
#pragma config LVP = OFF
#pragma config XINST = OFF
#pragma config DEBUG = ON

#pragma config CP0 = OFF
#pragma config CPB = OFF
#pragma config WRT0 = OFF
#pragma config WRTB = OFF
#pragma config EBTR0 = OFF
#pragma config EBTRB = OFF

/****** Delay *******************************************/
#include <delays.h>
#pragma code
void Delay_us(Word num){          // 1...4266 uS
	Word buff;
	if( num == 1 ){
		Delay10TCYx(1);
	}
	else if( num < 426 ){
		buff = num*3/5;
		Delay10TCYx(buff);
	}
	else if( num < 4266 ){
		buff = num*3/50;
		Delay100TCYx(buff);
	}
	else  Delay100TCYx(255);
}

void Delay_ms(Word num){          // 1...1280 mS
	Word buff;
	if( num < 43 ){
		buff = num*6;
		Delay1KTCYx(buff);
	}
	else if( num < 426 ){
		buff = num*3/5;
		Delay10KTCYx(buff);
	}
	else if( num < 853 ){
		buff = num*3/10;
		Delay10KTCYx(buff);
		Delay10KTCYx(buff);
	}
	else if( num < 1280 ){
		buff = num/5;
		Delay10KTCYx(buff);
		Delay10KTCYx(buff);
		Delay10KTCYx(buff);
	}
	else {
        Delay10KTCYx(255);
        Delay10KTCYx(255);
        Delay10KTCYx(255);
	}
}
//******************************************************************************
#pragma interrupt ISR             // ݐ錾(D揇ʎgȂ)
#pragma code ISR = 0x08           // ݃xN^ւjmp߃Zbg
void Jump_ISR(void){
   _asm  goto ISR  _endasm
}
extern void ISR_Init(void);
