#include "_k_Pic18.h"  // 18F2550 , 20 -> 24MHz , Byte... , Delay_us/ms
#include "_k_Lcd.c"

rom const Byte *strt = {"START"};  // START\p
volatile Byte  tt, tts;
#define  LED0  LATCbits.LATC0      // LED `
#define  CL_io  TRISAbits.TRISA3
#define  DT_io  TRISAbits.TRISA2
#define  CL_bit PORTAbits.RA3
#define  DT_bit PORTAbits.RA2
#define  Done   0
#define  Erra   1
#define  Short_Time  6
#define  Long_Time   120
Byte  m1,m2,m3,m4,kk,mtype, pp, xx;


//------------------------------------------------------------------------------
void start_up(void){
   TRISA=0; TRISB=0; TRISC=0;
   INTCON=0;              // Disable all interrupts
   ADCON1=0x0F;           // all pins as digital inputs
   k_Lcd_Init();
   k_Lcd_Cur(0);          // LCD cursor off
   k_Lcd_Cls();           // LCD clear
   Delay_ms(500);
}
// ------------------------------------------------------
void  Wait_CL_H2L( void ){
   while ( CL_bit == 0 ) Nop();
   while ( CL_bit == 1 ) Nop();
}

Byte  Mouse_Read_B ( Byte *pp ){
Byte  k, p, ii, result;
   result=Erra;
   do{
      Wait_CL_H2L();
      Delay_us(Short_Time);
   }while ( DT_bit );       // Wait for Start Bit
   p=0;
   for ( k=0; k<=7; k++){   // 8bit
     Wait_CL_H2L();
     Delay_us(Short_Time);
     ii=DT_bit;
     p |= (ii<<k);
   }
   Wait_CL_H2L();           // Parity Bit
   *pp=p;
   Wait_CL_H2L();           // Stop Bit
   result=Done;
   return (result);
}

Byte  Mouse_Write_B ( Byte dd ){
Byte  pari, k, result;
  result=Erra;
  CL_io=0;  DT_io=0;      // set Output mode
  CL_bit=0;               // Pulldown Clock Line
  Delay_us(Long_Time);        // >100us
  DT_bit=0;               // Pulldown Data Line
  Delay_us(Short_Time);
  CL_io=1;                // Release Clock Line
  pari=1;
  for ( k=0; k<=7; k++){
     Wait_CL_H2L();
     DT_bit=dd & 1;       // Send 1 bit
     pari ^= dd;
     dd = dd >> 1;
  }
  Wait_CL_H2L();
  DT_bit=pari & 1;         // Send Parity bit
  Wait_CL_H2L();
  DT_io=1;                 // Release Data Line
  while ( DT_bit ) Nop();  // Wait for Data Low
  Wait_CL_H2L();           // Wait for Clock Low
  while ( DT_bit == 0 )  Nop();  // Wait for Data Release
  return (result);
}

Byte  Check_ACK( void ){
Byte  pp, result;
   result = Mouse_Read_B( &pp );
//  if ( pp != 0xFA )         // Ack ?
//    result = Erra;
   return (result);
}

Byte  Mouse_Read ( void ){
   Mouse_Read_B(&m1);
   Mouse_Read_B(&m2);
   return ( Mouse_Read_B(&m3) );
}

Byte  Mouse_Init ( Byte *tt ){
Byte  i, k, result;
  for ( i=0; i<=2; i++){    // 3 Times
     Mouse_Write_B(0xFF);     // Reset Command
     result=Check_ACK();      // Ack ?
     result=Mouse_Read_B(&xx);  // BAT
     Mouse_Read_B(&xx);         // mouse ID
  }
                        // Intellimouse Extension
  Mouse_Write_B(0xF3);       // Set sample rate Command
  result=Check_ACK();        // Ack ?
  Mouse_Write_B(200);
  result=Check_ACK();
  Mouse_Write_B(0xF3);       // Set sample rate Command
  result=Check_ACK();
  Mouse_Write_B(100);
  result=Check_ACK();
  Mouse_Write_B(0xF3);       // Set sample rate Command
  result=Check_ACK();
  Mouse_Write_B(80);
  result=Check_ACK();
  Mouse_Write_B(0xF2);       // Get Device ID Command
  result=Check_ACK();
  Mouse_Read_B(tt);

  Mouse_Write_B(0xF4);       // Enable Data Reporting Command
  result=Check_ACK();        // Ack ?
  return (result);
}
//***** C ***************************************************************
void main(){               /* main prog */
  start_up();  k_Lcd_Print_ROM(strt);
  LED0 = 1;
//  ISR_Init();		      // ISR(TMR0) 
  Delay_ms(500);
  kk = Mouse_Init(&mtype); // mouse ID
  kk = mtype+0x30;         //   =0 : standard
                           //   =3 : intelli
  LED0 = 0;
  while (1){
    if ( Mouse_Read() == Done ){
       if ( mtype > 0 )  xx=Mouse_Read_B(&m4);
       if ( LED0 )  LED0=0; else LED0=1;
       k_Lcd_Locate ( 1, 1 );

       xx=' ';  if ( m1 & 1 )  xx='L';
       k_Lcd_OutD(xx);

       xx=' ';  if ( m1 & 4 )  xx='C';
       k_Lcd_OutD(xx);

       xx=' ';  if ( m1 & 2 )  xx='R';
       k_Lcd_OutD(xx);

       k_Lcd_Print_ROM(" X=");
       if ( ( m1 & 0x10 ) == 0 )  k_Lcd_OutD('+');
       else {
          m2 = ~ m2;  m2 ++;
          k_Lcd_OutD('-');
       }
       //      LCD.Write(DecToStr(m2,2))    ' 99
       xx=m2/10;      k_Lcd_OutD(xx+0x30);
       xx=m2-(xx*10); k_Lcd_OutD(xx+0x30);

       k_Lcd_Print_ROM(" Y=");
       if ( ( m1 & 0x20 ) == 0 )  k_Lcd_OutD('+');
       else {
          m3 = ~ m3;  m3 ++;
          k_Lcd_OutD('-');
       }
       //      LCD.Write(DecToStr(m3,2))    ' 99
       xx=m3/10;      k_Lcd_OutD(xx+0x30);
       xx=m3-(xx*10); k_Lcd_OutD(xx+0x30);

       k_Lcd_Locate (2, 5 );
       if ( mtype>0 ){
          k_Lcd_Print_ROM(" Z=");
          if ( ( m4 & 0x80 ) == 0 )  k_Lcd_OutD('+');
          else {
             m4 = ~ m4;  m4 ++;
             k_Lcd_OutD('-');
          }
          //      LCD.Write(DecToStr(m4,2))    ' 99
          xx=m4/10;      k_Lcd_OutD(xx+0x30);
          xx=m4-(xx*10); k_Lcd_OutD(xx+0x30);
       }
    }
  }
}
//***** ݏ *********************************************************
void  usr_ISR_Init ( void ){
    Nop();
}
void ISR_Init(void){
    tt=0;  tts=0;
	T0CON = 0b01000111;
                    // TMR0ON = 0;   // Disable TMR0
	                // T08BIT = 1;   // TMR0 is working in 8 Bit mode
	                // T0CS = 0;     // TMR increments from internal clock
	                // T0SE = 0;     // Only used  external source
                    // PSA = 0;      // Ensure the Clock source uses the Prescaler
	                // .2 = 1;       // Prescaler bits
	                // .1 = 1;       //    1:256
	                // .0 = 1;       // (256-22)=234, 234*1/6*256=9.984mS
	TMR0L = 22;                  // Set the TMR0 register
	INTCONbits.TMR0IE = 1;       // Enable TMR0 Interrupts
	T0CONbits.TMR0ON = 1;

    usr_ISR_Init();
	INTCONbits.GIE = 1;          //S荞݂
}
//***** ݏ ***************************************************************
void usr_ISR ( void ){
   Nop();
}
/*********************************************************/
void ISR(void){                  // 荞݊֐
   if(INTCONbits.T0IF){          // ^C}0荞݁H
        INTCONbits.T0IF=0;       // ^C}0荞݃tO0ɂ
        TMR0L = 22;              // Re-Set the TMR0 register
		tt++;
   }
   else usr_ISR();
}
